<?php

namespace Kraken\Filesystem\Factory;

use Aws\S3\S3Client;
use League\Flysystem\AdapterInterface;
use League\Flysystem\AwsS3v2\AwsS3Adapter;
use Kraken\Filesystem\FilesystemAdapterSimpleFactory;
use Kraken\Pattern\Factory\SimpleFactoryInterface;

class Aws3v2Factory extends FilesystemAdapterSimpleFactory implements SimpleFactoryInterface
{
    /**
     * @return mixed[]
     */
    protected function getDefaults()
    {
        return [
            'bucket'    => '',
            'prefix'    => null,
            'options'   => []
        ];
    }

    /**
     * @param mixed[] $config
     * @return AdapterInterface
     */
    protected function onCreate($config = [])
    {
        return new AwsS3Adapter(
            S3Client::factory($this->params($config)),
            $this->param($config, 'bucket'),
            $this->param($config, 'prefix'),
            $this->param($config, 'options')
        );
    }
}
